# std::queue< _Tp, _Sequence > Class Template Reference
[Containers, Sequences]

List of all members.

## Detailed Description

### template<typename _Tp, typename _Sequence = deque<_Tp>>
class std::queue< _Tp, _Sequence >

Meets many of the requirements of a container, but does not define anything to do with iterators. Very few of the other standard container interfaces are defined.

This is not a true container, but an adaptor. It holds another container, and provides a wrapper interface to that container. The wrapper is what enforces strict first-in-first-out queue behavior.

The second template parameter defines the type of the underlying sequence/container. It defaults to std::deque, but it can be any type that supports `front`, `back`, `push_back`, and `pop_front`, such as std::list or an appropriate user-defined type.

Members not found in "normal" containers are `container_type`, which is a typedef for the second Sequence parameter, and `push` and `pop`, which are standard queue/FIFO operations.

Definition at line 95 of file stl_queue.h.

## Public Types

- typedef _Sequence::const_reference const_reference
- typedef _Sequence container_type
- typedef _Sequence::reference reference
- typedef _Sequence::size_type size_type
- typedef _Sequence::value_type value_type

## Public Member Functions

- const_reference back () const
- reference back ()
- bool empty () const
- const_reference front () const
- reference front ()
- void pop ()
- void push (const value_type &__x)
- queue (const _Sequence &__c=_Sequence())
- size_type size () const

## Protected Attributes

- _Sequence c

## Friends

- template<typename _Tp1, typename _Seq1> bool operator< (const queue< _Tp1, _Seq1 > &, const queue< _Tp1, _Seq1 > &)
- template<typename _Tp1, typename _Seq1> bool operator== (const queue< _Tp1, _Seq1 > &, const queue< _Tp1, _Seq1 > &)

## Constructor & Destructor Documentation

template<typename _Tp, typename _Sequence = deque<_Tp>>

std::queue< _Tp, _Sequence >::queue | ( | const _Sequence & | __c = `_Sequence()` | ) | `[inline, explicit]`

Default constructor creates no elements.

Definition at line 135 of file stl_queue.h.

## Member Function Documentation

template<typename _Tp, typename _Sequence = deque<_Tp>>

const_reference std::queue< _Tp, _Sequence >::back | ( |  | ) | const`[inline]`

Returns a read-only (constant) reference to the data at the last element of the queue.

Definition at line 187 of file stl_queue.h.

References __glibcxx_requires_nonempty.

template<typename _Tp, typename _Sequence = deque<_Tp>>

reference std::queue< _Tp, _Sequence >::back | ( |  | ) | `[inline]`

Returns a read/write reference to the data at the last element of the queue.

Definition at line 176 of file stl_queue.h.

References __glibcxx_requires_nonempty.

template<typename _Tp, typename _Sequence = deque<_Tp>>

bool std::queue< _Tp, _Sequence >::empty | ( |  | ) | const`[inline]`

Returns true if the queue is empty.

Definition at line 141 of file stl_queue.h.

template<typename _Tp, typename _Sequence = deque<_Tp>>

const_reference std::queue< _Tp, _Sequence >::front | ( |  | ) | const`[inline]`

Returns a read-only (constant) reference to the data at the first element of the queue.

Definition at line 165 of file stl_queue.h.

References __glibcxx_requires_nonempty.

template<typename _Tp, typename _Sequence = deque<_Tp>>

reference std::queue< _Tp, _Sequence >::front | ( |  | ) | `[inline]`

Returns a read/write reference to the data at the first element of the queue.

Definition at line 154 of file stl_queue.h.

References __glibcxx_requires_nonempty.

template<typename _Tp, typename _Sequence = deque<_Tp>>

void std::queue< _Tp, _Sequence >::pop | ( |  | ) | `[inline]`

Removes first element.

This is a typical queue operation. It shrinks the queue by one. The time complexity of the operation depends on the underlying sequence.

Note that no data is returned, and if the first element's data is needed, it should be retrieved before pop() is called.

Definition at line 218 of file stl_queue.h.

References __glibcxx_requires_nonempty.

template<typename _Tp, typename _Sequence = deque<_Tp>>

void std::queue< _Tp, _Sequence >::push | ( | const value_type & | __x | ) | `[inline]`

Add data to the end of the queue.

Parameters:

  | x | Data to be added.

This is a typical queue operation. The function creates an element at the end of the queue and assigns the given data to it. The time complexity of the operation depends on the underlying sequence.

Definition at line 203 of file stl_queue.h.

template<typename _Tp, typename _Sequence = deque<_Tp>>

size_type std::queue< _Tp, _Sequence >::size | ( |  | ) | const`[inline]`

Returns the number of elements in the queue.

Definition at line 146 of file stl_queue.h.

## Member Data Documentation

template<typename _Tp, typename _Sequence = deque<_Tp>>

_Sequence std::queue< _Tp, _Sequence >::c `[protected]`

'c' is the underlying container. Maintainers wondering why this isn't uglified as per style guidelines should note that this name is specified in the standard, [23.2.3.1]. (Why? Presumably for the same reason that it's protected instead of private: to allow derivation. But none of the other containers allow for derivation. Odd.)

Definition at line 128 of file stl_queue.h.

Referenced by std::operator==().

The documentation for this class was generated from the following file:

- stl_queue.h